/**
 * A simple function to use Emmet in a web environment
 * @property {Boolean} [firstChild=false] When set to true the result to the zen function is an HTMLElement when the length of the NodeList is one. Default is false.
 * @param {string} abbreviation The Emmet abbreviation to expand.
 * @param {Object} [content] An optional content object to replace strings from the result.
 * @returns {Array} The Emmet result in an Array.
 * @version 0.1.5
 * @author Ron Valstar <ron@ronvalstar.nl>
 * @licence MIT: http://www.opensource.org/licenses/mit-license.php
 * @requires Emmet (currently using revision c973f3d)
 * @copyright Emmet 2012 Sergey Chikuyonok <serge.che@gmail.com>
 */
var zen=function(){function t(){}var n=function(){var n=this,e=(n._,{}),r=Array.prototype,i=Object.prototype,u=Function.prototype,o=r.slice,a=(r.unshift,i.toString),s=i.hasOwnProperty,c=r.forEach,f=r.map,l=r.reduce,p=(r.reduceRight,r.filter),d=(r.every,r.some,r.indexOf),h=(r.lastIndexOf,Array.isArray),g=Object.keys,m=u.bind,v=t;"undefined"!=typeof exports?("undefined"!=typeof module&&module.exports&&(exports=module.exports=v),exports._=v):n._=v,v.VERSION="1.3.3";var b=v.each=v.forEach=function(t,n,r){if(null!=t)if(c&&t.forEach===c)t.forEach(n,r);else if(t.length===+t.length){for(var i=0,u=t.length;u>i;i++)if(i in t&&n.call(r,t[i],i,t)===e)return}else for(var o in t)if(v.has(t,o)&&n.call(r,t[o],o,t)===e)return};v.map=v.collect=function(n,e,r){var i=[];return null==n?i:f&&n.map===f?n.map(e,r):(b(n,t),n.length===+n.length&&(i.length=n.length),i)},v.reduce=v.foldl=v.inject=function(t,n,e,r){var i=arguments.length>2;if(null==t&&(t=[]),l&&t.reduce===l)return r&&(n=v.bind(n,r)),i?t.reduce(n,e):t.reduce(n);if(b(t,function(t,u,o){i?e=n.call(r,e,t,u,o):(e=t,i=!0)}),!i)throw new TypeError("Reduce of empty array with no initial value");return e},v.reduceRight=v.foldr=t,v.find=v.detect=t,v.filter=v.select=function(n,e,r){var i=[];return null==n?i:p&&n.filter===p?n.filter(e,r):(b(n,t),i)},v.reject=t,v.every=v.all=t;var x=v.some=v.any=t;v.include=v.contains=function(n,e){var r=!1;return null==n?r:d&&n.indexOf===d?-1!=n.indexOf(e):r=x(n,t)},v.invoke=t,v.pluck=t,v.max=t,v.min=t,v.shuffle=t,v.sortBy=t,v.groupBy=t,v.sortedIndex=t,v.toArray=t,v.size=t,v.first=v.head=v.take=t,v.initial=t,v.last=t,v.rest=v.tail=function(t,n,e){return o.call(t,null==n||e?1:n)},v.compact=t,v.flatten=function(t,n){return v.reduce(t,function(t,e){return v.isArray(e)?t.concat(n?e:v.flatten(e)):(t[t.length]=e,t)},[])},v.without=t,v.uniq=v.unique=t,v.union=t,v.intersection=v.intersect=t,v.difference=t,v.zip=t,v.indexOf=function(t,n,e){if(null==t)return-1;var r,i;if(e)return r=v.sortedIndex(t,n),t[r]===n?r:-1;if(d&&t.indexOf===d)return t.indexOf(n);for(r=0,i=t.length;i>r;r++)if(r in t&&t[r]===n)return r;return-1},v.lastIndexOf=t,v.range=t,v.bind=function(n){var e,r;if(n.bind===m&&m)return m.apply(n,o.call(arguments,1));if(!v.isFunction(n))throw new TypeError;return r=o.call(arguments,2),e=t},v.bindAll=t,v.memoize=t,v.delay=t,v.defer=t,v.throttle=t,v.debounce=t,v.once=t,v.wrap=t,v.compose=t,v.after=t,v.keys=g||t,v.values=t,v.functions=v.methods=function(t){var n=[];for(var e in t)v.isFunction(t[e])&&n.push(e);return n.sort()},v.extend=function(t){return b(o.call(arguments,1),function(n){for(var e in n)t[e]=n[e]}),t},v.pick=t,v.defaults=t,v.clone=function(t){return v.isObject(t)?v.isArray(t)?t.slice():v.extend({},t):t},v.tap=t,v.isEqual=t,v.isEmpty=t,v.isElement=t,v.isArray=h||t,v.isObject=function(t){return t===Object(t)},v.isArguments=function(t){return"[object Arguments]"==a.call(t)},v.isArguments(arguments)||(v.isArguments=t),v.isFunction=function(t){return"[object Function]"==a.call(t)},v.isString=function(t){return"[object String]"==a.call(t)},v.isNumber=function(t){return"[object Number]"==a.call(t)},v.isFinite=t,v.isNaN=t,v.isBoolean=t,v.isDate=t,v.isRegExp=t,v.isNull=t,v.isUndefined=function(t){return void 0===t},v.has=function(t,n){return s.call(t,n)},v.noConflict=t,v.identity=t,v.times=t,v.escape=t,v.result=t,v.mixin=function(t){b(v.functions(t),function(n){w(n,v[n]=t[n])})},v.uniqueId=t,v.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var y={"\\":"\\","'":"'",r:"\r",n:"\n",t:"	",u2028:"\u2028",u2029:"\u2029"};for(var _ in y)y[y[_]]=_;v.template=t,v.chain=t;var S=t;v.prototype=S.prototype;var w=function(n){S.prototype[n]=t};return v.mixin(v),b(["pop","push","reverse","shift","sort","splice","unshift"],function(n){r[n],S.prototype[n]=t}),b(["concat","join","slice"],function(n){r[n],S.prototype[n]=t}),S.prototype.chain=t,S.prototype.value=t,v}.call({}),e=function(e){function r(t){return t in o||!a||a(t),o[t]}var i="html";if("undefined"==typeof n)try{n=e[["require"][0]]("underscore")}catch(u){}if("undefined"==typeof n)throw"Cannot access to Underscore.js lib";var o={_:n},a=null;return{define:function(t,e){t in o||(o[t]=n.isFunction(e)?this.exec(e):e)},require:r,exec:function(t,i){return t.call(i||e,n.bind(r,this),n,this)},extend:t,expandAbbreviation:function(t,n,e,u){if(!t)return"";n=n||i;var o=r("filters"),a=r("abbreviationParser");e=r("profile").get(e,n),r("tabStops").resetTabstopIndex();var s=o.extractFromAbbreviation(t),c=a.parse(s[0],{syntax:n,contextNode:u}),f=o.composeList(n,e,s[1]);return o.apply(c,f,e),c.toString()},defaultSyntax:t,defaultProfile:t,log:t,setModuleLoader:t}}(this);"undefined"!=typeof exports&&("undefined"!=typeof module&&module.exports&&(exports=module.exports=e),exports.emmet=e),"undefined"!=typeof define&&define(e),e.define("abbreviationParser",function(n,e){function r(){this.parent=null,this.children=[],this._attributes=[],this.abbreviation="",this.counter=1,this._name=null,this._text="",this.repeatCount=1,this.hasImplicitRepeat=!1,this._data={},this.start="",this.end="",this.content="",this.padding=""}function i(t){return t.substring(1,t.length-1)}function u(t,n){for(var e;e=t.next();)if(e===n)return!0;return!1}function o(t){t=n("utils").trim(t);for(var u,a,s=new r,c=s.addChild(),f=n("stringStream").create(t),l=1e3;!f.eol()&&--l>0;)switch(u=f.peek()){case"(":if(f.start=f.pos,!f.skipToPair("(",")"))throw'Invalid abbreviation: mo matching ")" found for character at '+f.pos;var p=o(i(f.current()));(a=f.match(/^\*(\d+)?/,!0))&&c._setRepeat(a[1]),e.each(p.children,function(t){c.addChild(t)});break;case">":c=c.addChild(),f.next();break;case"+":c=c.parent.addChild(),f.next();break;case"^":var h=c.parent||c;c=(h.parent||h).addChild(),f.next();break;default:f.start=f.pos,f.eatWhile(function(t){if("["==t||"{"==t){if(f.skipToPair(t,m[t]))return f.backUp(1),!0;throw'Invalid abbreviation: mo matching "'+m[t]+'" found for character at '+f.pos}if("+"==t){f.next();var n=f.eol()||~"+>^*".indexOf(f.peek());return f.backUp(1),n}return"("!=t&&d(t)}),c.setAbbreviation(f.current()),f.start=f.pos}if(1>l)throw"Endless loop detected";return s}function a(t){t=n("utils").trim(t);var e=[],r=n("stringStream").create(t);for(r.eatSpace();!r.eol()&&(r.start=r.pos,r.eatWhile(g));){var i=r.current(),o="";if("="==r.peek()){r.next(),r.start=r.pos;var a=r.peek();if('"'==a||"'"==a){if(r.next(),!u(r,a))throw"Invalid attribute value";o=r.current(),o=o.substring(1,o.length-1)}else{if(!r.eatWhile(/[^\s\]]/))throw"Invalid attribute value";o=r.current()}}e.push({name:i,value:o}),r.eatSpace()}return e}function s(t){for(var e=[],r={"#":"id",".":"class"},u=null,o=n("stringStream").create(t);!o.eol();)switch(o.peek()){case"#":case".":null===u&&(u=o.pos);var s=r[o.peek()];o.next(),o.start=o.pos,o.eatWhile(g),e.push({name:s,value:o.current()});break;case"[":if(null===u&&(u=o.pos),o.start=o.pos,!o.skipToPair("[","]"))throw"Invalid attribute set definition";e=e.concat(a(i(o.current())));break;default:o.next()}return e.length?{element:t.substring(0,u),attributes:c(e)}:null}function c(t){t=e.map(t,function(t){return e.clone(t)});var n={};return e.filter(t,function(t){if(!(t.name in n))return n[t.name]=t;var e=n[t.name];return"class"==t.name.toLowerCase()?e.value+=(e.value.length?" ":"")+t.value:e.value=t.value,!1})}function f(t){if(!~t.indexOf("{"))return null;for(var e=n("stringStream").create(t);!e.eol();)switch(e.peek()){case"[":case"(":e.skipToPair(e.peek(),m[e.peek()]);break;case"{":return e.start=e.pos,e.skipToPair("{","}"),{element:t.substring(0,e.start),text:i(e.current())};default:e.next()}}function l(t){for(var n,r,i,u=t.children.length-1;u>=0;u--)if(r=t.children[u],r.isRepeating())for(i=n=r.repeatCount,r.repeatCount=1,r.updateProperty("counter",1),r.updateProperty("maxCount",i);--n>0;)r.parent.addChild(r.clone(),u+1).updateProperty("counter",n+1).updateProperty("maxCount",i);return e.each(t.children,l),t}function p(t){for(var n=t.children.length-1;n>=0;n--){var r=t.children[n];r.isGroup()?r.replace(p(r).children):r.isEmpty()&&r.remove()}return e.each(t.children,p),t}function d(t){var n=t.charCodeAt(0),e="#.*:$-_!@|%";return n>64&&91>n||n>96&&123>n||n>47&&58>n||-1!=e.indexOf(t)}var h=/^[\w\-\$\:@\!%]+\+?$/i,g=/[\w\-:\$@]/,m={"[":"]","(":")","{":"}"},v=Array.prototype.splice,b=[],x=[],y=[];return r.prototype={addChild:function(t,n){return t=t||new r,t.parent=this,e.isUndefined(n)?this.children.push(t):this.children.splice(n,0,t),t},clone:function(){var t=new r,n=["abbreviation","counter","_name","_text","repeatCount","hasImplicitRepeat","start","end","content","padding"];return e.each(n,function(n){t[n]=this[n]},this),t._attributes=e.map(this._attributes,function(t){return e.clone(t)}),t._data=e.clone(this._data),t.children=e.map(this.children,function(n){return n=n.clone(),n.parent=t,n}),t},remove:t,replace:function(){var t=this.parent,n=e.indexOf(t.children,this),r=e.flatten(arguments);v.apply(t.children,[n,1].concat(r)),e.each(r,function(n){n.parent=t})},updateProperty:function(t,n){return this[t]=n,e.each(this.children,function(e){e.updateProperty(t,n)}),this},find:t,findAll:t,data:function(t,e){return 2==arguments.length&&(this._data[t]=e,"resource"==t&&n("elements").is(e,"snippet")&&(this.content=e.data,this._text&&(this.content=n("abbreviationUtils").insertChildContent(e.data,this._text)))),this._data[t]},name:function(){var t=this.matchedResource();return n("elements").is(t,"element")?t.name:this._name},attributeList:function(){var t=[],r=this.matchedResource();return n("elements").is(r,"element")&&e.isArray(r.attributes)&&(t=t.concat(r.attributes)),c(t.concat(this._attributes))},attribute:t,matchedResource:function(){return this.data("resource")},index:t,_setRepeat:function(t){t?this.repeatCount=parseInt(t,10)||1:this.hasImplicitRepeat=!0},setAbbreviation:function(t){t=t||"";var n=this;t=t.replace(/\*(\d+)?$/,function(t,e){return n._setRepeat(e),""}),this.abbreviation=t;var e=f(t);e&&(t=e.element,this.content=this._text=e.text);var r=s(t);if(r&&(t=r.element,this._attributes=r.attributes),this._name=t,this._name&&!h.test(this._name))throw"Invalid abbreviation"},toString:function(){var t=n("utils"),r=this.start,i=this.end,u=this.content,o=this;e.each(y,function(t){r=t(r,o,"start"),u=t(u,o,"content"),i=t(i,o,"end")});var a=e.map(this.children,function(t){return t.toString()}).join("");return u=n("abbreviationUtils").insertChildContent(u,a,{keepVariable:!1}),r+t.padString(u,this.padding)+i},hasEmptyChildren:t,hasImplicitName:t,isGroup:function(){return!this.abbreviation},isEmpty:function(){return!this.abbreviation&&!this.children.length},isRepeating:function(){return this.repeatCount>1||this.hasImplicitRepeat},isTextNode:function(){return!this.name()&&!this.attributeList().length},isElement:t,deepestChild:t},y.push(function(t,e){return n("utils").replaceCounter(t,e.counter,e.maxCount)}),{parse:function(n,r){r=r||{};var i=o(n);return r.contextNode&&(i._name=r.contextNode.name,e.each(i._attributes,t),e.each(r.contextNode.attributes,t)),e.each(b,t),i=p(l(i)),e.each(x,t),i},AbbreviationNode:r,addPreprocessor:t,removeFilter:t,addPostprocessor:t,removePostprocessor:t,addOutputProcessor:function(t){e.include(y,t)||y.push(t)},removeOutputProcessor:t,isAllowedChar:t}}),e.define("utils",function(n,e){function r(t){this._data=[],this.length=0,t&&this.append(t)}return r.prototype={append:function(t){this._data.push(t),this.length+=t.length},toString:function(){return this._data.join("")},valueOf:t},{reTag:/<\/?[\w:\-]+(?:\s+[\w\-:]+(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*\s*(\/?)>$/,endsWithTag:t,isNumeric:function(t){return"string"==typeof t&&(t=t.charCodeAt(0)),t&&t>47&&58>t},trim:function(t){return(t||"").replace(/^\s+|\s+$/g,"")},getNewline:function(){var t=n("resources");if(!t)return"\n";var r=t.getVariable("newline");return e.isString(r)?r:"\n"},setNewline:t,splitByLines:function(n,r){var i=this.getNewline(),u=(n||"").replace(/\r\n/g,"\n").replace(/\n\r/g,"\n").replace(/\r/g,"\n").replace(/\n/g,i).split(i);return r&&(u=e.filter(u,t,this)),u},normalizeNewline:t,repeatString:t,getStringsPads:t,padString:function(t,r){var i=e.isNumber(r)?this.repeatString(n("resources").getVariable("indentation")||"	",r):r,u=[],o=this.splitByLines(t),a=this.getNewline();u.push(o[0]);for(var s=1;s<o.length;s++)u.push(a+i+o[s]);return u.join("")},zeroPadString:function(t,n){for(var e="",r=t.length;n>r++;)e+="0";return e+t},unindentString:t,replaceUnescapedSymbol:function(t,n,r){for(var i=0,u=t.length,o=n.length,a=0;u>i;)if("\\"==t.charAt(i))i+=o+1;else if(t.substr(i,o)==n){var s=o;a++;var c=r;if(e.isFunction(r)){var f=r(t,n,i,a);f?(s=f[0].length,c=f[1]):c=!1}if(c===!1){i++;continue}t=t.substring(0,i)+c+t.substring(i+s),u=t.length,i+=c.length}else i++;return t},replaceVariables:function(r,i){return i=i||{},e.isFunction(i)?i:t,n("resources"),n("tabStops").processText(r,{variable:t})},replaceCounter:function(t,n,r){var i="$";t=String(t),n=String(n),/^\-?\d+$/.test(n)&&(n=+n);var u=this;return this.replaceUnescapedSymbol(t,i,function(t,i,o){if("{"==t.charAt(o+1)||u.isNumeric(t.charAt(o+1)))return!1;for(var a=o+1;"$"==t.charAt(a)&&"{"!=t.charAt(a+1);)a++;var s,c=a-o,f=0,l=!1;return(s=t.substr(a).match(/^@(\-?)(\d*)/))&&(a+=s[0].length,s[1]&&(l=!0),f=parseInt(s[2]||1)-1),l&&r&&e.isNumber(n)&&(n=r-n+1),n+=f,[t.substring(o,a),u.zeroPadString(n+"",c)]})},matchesTag:t,escapeText:t,unescapeText:t,getCaretPlaceholder:t,setCaretPlaceholder:t,getLinePadding:t,getLinePaddingFromPosition:t,escapeForRegexp:t,prettifyNumber:t,stringBuilder:function(t){return new r(t)},replaceSubstring:function(t,n,r,i){return e.isObject(r)&&"end"in r&&(i=r.end,r=r.start),e.isString(i)&&(i=r+i.length),e.isUndefined(i)&&(i=r),0>r||r>t.length?t:t.substring(0,r)+n+t.substring(i)},narrowToNonSpace:t,findNewlineBounds:t,deepMerge:function(){var t,n,r,i,u,o,a=arguments[0]||{},s=1,c=arguments.length;for(e.isObject(a)||e.isFunction(a)||(a={});c>s;s++)if(null!=(t=arguments[s]))for(n in t)r=a[n],i=t[n],a!==i&&(i&&(e.isObject(i)||(u=e.isArray(i)))?(u?(u=!1,o=r&&e.isArray(r)?r:[]):o=r&&e.isObject(r)?r:{},a[n]=this.deepMerge(o,i)):void 0!==i&&(a[n]=i));return a}}}),e.define("handlerList",function(){function n(){this._list=[]}return n.prototype={add:t,remove:t,list:t,listFn:t,exec:t},{create:function(){return new n}}}),e.define("stringStream",function(){function n(t){this.pos=this.start=0,this.string=t}return n.prototype={eol:function(){return this.pos>=this.string.length},sol:t,peek:function(){return this.string.charAt(this.pos)},next:function(){return this.pos<this.string.length?this.string.charAt(this.pos++):void 0},eat:function(t){var n,e=this.string.charAt(this.pos);return n="string"==typeof t?e==t:e&&(t.test?t.test(e):t(e)),n?(++this.pos,e):void 0},eatWhile:function(t){for(var n=this.pos;this.eat(t););return this.pos>n},eatSpace:function(){for(var t=this.pos;/[\s\u00a0]/.test(this.string.charAt(this.pos));)++this.pos;return this.pos>t},skipToEnd:t,skipTo:t,skipToPair:function(t,n){for(var e,r=0,i=this.pos,u=this.string.length;u>i;)if(e=this.string.charAt(i++),e==t)r++;else if(e==n&&(r--,1>r))return this.pos=i,!0;return!1},backUp:function(t){this.pos-=t},match:function(n,e,r){if("string"!=typeof n){var i=this.string.slice(this.pos).match(n);return i&&e!==!1&&(this.pos+=i[0].length),i}var u=r?t:t;return u(this.string).indexOf(u(n),this.pos)==this.pos?(e!==!1&&(this.pos+=n.length),!0):void 0},current:function(){return this.string.slice(this.start,this.pos)}},{create:function(t){return new n(t)}}}),e.define("resources",function(n,e){var r={},i={},u={};return n("handlerList").create(),{setVocabulary:t,getVocabulary:t,getMatchedResource:t,getVariable:function(t){return(this.getSection("variables")||{})[t]},setVariable:t,hasSyntax:t,addResolver:t,removeResolver:t,getSection:function(t){if(!t)return null;t in r||(r[t]=n("utils").deepMerge({},i[t],u[t]));for(var o,a=r[t],s=e.rest(arguments);a&&(o=s.shift());){if(!(o in a))return null;a=a[o]}return a},findItem:function(t,n){for(var e=this.getSection(t);e;){if(n in e)return e[n];e=this.getSection(e["extends"])}},findSnippet:t,fuzzyFindSnippet:t,getAllSnippets:t}}),e.define("profile",function(n,e){function r(t){e.extend(this,s,t)}function i(t,n){switch(String(n||"").toLowerCase()){case"lower":return t.toLowerCase();case"upper":return t.toUpperCase()}return t}function u(t,n){return a[t.toLowerCase()]=new r(n)}function o(){u("xhtml"),u("html",{self_closing_tag:!1}),u("xml",{self_closing_tag:!0,tag_nl:!0}),u("plain",{tag_nl:!1,indent:!1,place_cursor:!1}),u("line",{tag_nl:!1,indent:!1,extraFilters:"s"})}var a={},s={tag_case:"asis",attr_case:"asis",attr_quotes:"double",tag_nl:"decide",tag_nl_leaf:!1,place_cursor:!0,indent:!0,inline_break:3,self_closing_tag:"xhtml",filters:"",extraFilters:""};return r.prototype={tagName:function(t){return i(t,this.tag_case)},attributeName:function(t){return i(t,this.attr_case)},attributeQuote:function(){return"single"==this.attr_quotes?"'":'"'},selfClosing:t,cursor:function(){return this.place_cursor?n("utils").getCaretPlaceholder():""}},o(),{create:t,get:function(t,i){if(!t&&i){var u=n("resources").findItem(i,"profile");u&&(t=u)}return t?t instanceof r?t:e.isString(t)&&t.toLowerCase()in a?a[t.toLowerCase()]:this.create(t):a.plain},remove:t,reset:t,stringCase:i}}),e.define("abbreviationUtils",function(n,e){return{isSnippet:t,isUnary:function(t){if(t.children.length||t._text||this.isSnippet(t))return!1;var n=t.matchedResource();return n&&n.is_empty},isInline:t,isBlock:t,isSnippet:function(t){return n("elements").is(t.matchedResource(),"snippet")},hasTagsInContent:t,hasBlockChildren:t,insertChildContent:function(r,i,u){u=e.extend({keepVariable:!0,appendIfNoChild:!0},u||{});var o=!1,a=n("utils");return r=a.replaceVariables(r,t),!o&&u.appendIfNoChild&&(r+=i),r}}}),e.define("htmlMatcher",function(){return{find:t,tag:t}}),e.define("tabStops",function(n,e){var r=100,i=0,u={replaceCarets:!1,escape:t,tabstop:t,variable:t};return n("abbreviationParser").addOutputProcessor(function(e,r){var u=0,o=n("tabStops"),a=n("utils"),s={tabstop:t};return e=o.processText(e,s),e=a.replaceVariables(e,o.variablesResolver(r)),i+=u+1,e}),{extract:t,processText:function(t,r){r=e.extend({},u,r);for(var i,o,a,s=n("utils").stringBuilder(),c=n("stringStream").create(t);i=c.next();)if("\\"!=i||c.eol()){if(a=i,"$"==i)if(c.start=c.pos-1,o=c.match(/^[0-9]+/))a=r.tabstop({start:s.length,group:c.current().substr(1),token:c.current()});else if(o=c.match(/^\{([a-z_\-][\w\-]*)\}/))a=r.variable({start:s.length,name:o[1],token:c.current()});else if(o=c.match(/^\{([0-9]+)(:.+?)?\}/,!1)){c.skipToPair("{","}");var f={start:s.length,group:o[1],token:c.current()},l=f.token.substring(f.group.length+2,f.token.length-1);l&&(f.placeholder=l.substr(1)),a=r.tabstop(f)}s.append(a)}else s.append(r.escape(c.next()));return s.toString()},upgrade:t,variablesResolver:function(){return n("resources"),t},resetTabstopIndex:function(){i=0,r=100}}}),e.define("preferences",function(n,e){function r(t){return e.isObject(t)&&"value"in t&&e.keys(t).length<3}var i={},u={};return{define:function(t,n,i){var o=t;e.isString(t)&&(o={},o[t]={value:n,description:i}),e.each(o,function(t,n){u[n]=r(t)?t:{value:t}})},set:t,get:function(t){return t in i?i[t]:t in u?u[t].value:void 0},getArray:function(t){var r=this.get(t);return e.isUndefined(r)||(r=e.map(r.split(","),n("utils").trim),r.length||(r=null)),r},getDict:t,description:t,remove:t,list:t,load:t,exportModified:t,reset:t,_startTest:t,_stopTest:t}}),e.define("elements",function(){function n(){}var e={},r={add:function(n){e[n]=t},get:t,create:t,is:function(t,n){return t&&t.type===n}};return r.add("element",t),r.add("snippet",n),r.add("reference",n),r.add("empty",t),r}),e.define("filters",function(n,e){function r(t){return t?e.isString(t)?t.split(/[\|,]/g):t:[]}var i={},u="html";return{add:function(t,n){i[t]=n},apply:function(t,u,o){var a=n("utils");return o=n("profile").get(o),e.each(r(u),function(n){var e=a.trim(n.toLowerCase());e&&e in i&&(t=i[e](t,o))}),t},composeList:function(t,e,i){e=n("profile").get(e);var o=r(e.filters||n("resources").findItem(t,"filters")||u);return e.extraFilters&&(o=o.concat(r(e.extraFilters))),i&&(o=o.concat(r(i))),o&&o.length||(o=r(u)),o},extractFromAbbreviation:function(n){var e="";return n=n.replace(/\|([\w\|\-]+)$/,t),[n,r(e)]}}}),e.exec(function(t,n){function e(e){return n.include(l.getArray("format.noIndentTags")||[],e.name())?"":t("resources").getVariable("indentation")}function r(){}function i(){}function u(){}function o(){}function a(){}function s(){}function c(a,c){a.start=a.end=f;var p=t("utils"),d=t("abbreviationUtils"),h=d.isUnary(a),g=p.getNewline(),m=e(a);if(c.tag_nl!==!1){var v=c.tag_nl===!0&&(c.tag_nl_leaf||a.children.length);v||(v=n.include(l.getArray("format.forceIndentationForTags")||[],a.name())),a.isTextNode()||(u(a,c)?(i(a)||d.isSnippet(a.parent)&&!a.index()||(a.start=g+a.start),(d.hasBlockChildren(a)||o(a,c)||v&&!h)&&(a.end=g+a.end),(d.hasTagsInContent(a)||v&&!a.children.length&&!h)&&(a.start+=g+m)):d.isInline(a)&&r(a)&&!i(a)?a.start=g+a.start:d.isInline(a)&&s(a,c)&&(a.end=g+a.end),a.padding=m)}return a}var f="%s",l=t("preferences");l.define("format.noIndentTags","html","A comma-separated list of tag names that should not get inner indentation."),l.define("format.forceIndentationForTags","body","A comma-separated list of tag names that should <em>always</em> get inner indentation."),t("filters").add("_format",function p(e,r,i){i=i||0;var u=t("abbreviationUtils");return n.each(e.children,function(t){u.isSnippet(t)?a(t,r,i):c(t,r,i),p(t,r,i+1)}),e})}),e.exec(function(t,n){function e(t,e){var r=e.attributeQuote(),i=e.cursor();return n.map(t.attributeList(),function(t){var n=e.attributeName(t.name);return" "+n+"="+r+(t.value||i)+r}).join("")}function r(n,r){if(!n.parent)return n;var i=t("abbreviationUtils"),u=t("utils"),o=e(n,r),a=r.cursor(),s=i.isUnary(n),c="",f="";if(!n.isTextNode()){var l=r.tagName(n.name());s?(c="<"+l+o+r.selfClosing()+">",n.end=""):(c="<"+l+o+">",f="</"+l+">")}var p="%s";return n.start=u.replaceSubstring(n.start,c,n.start.indexOf(p),p),n.end=u.replaceSubstring(n.end,f,n.end.indexOf(p),p),n.children.length||s||~n.content.indexOf(a)||t("tabStops").extract(n.content).tabstops.length||(n.start+=a),n}t("filters").add("html",function i(e,u,o){o=o||0;var a=t("abbreviationUtils");return o||(e=t("filters").apply(e,"_format",u)),n.each(e.children,function(t){a.isSnippet(t)||r(t,u,o),i(t,u,o+1)}),e})});var r=function(t){"use strict";var n=document.createElement("div"),e=n.childNodes,r=function(i,u){var o,a,s=[],c=t.expandAbbreviation(i);if(void 0!==u)for(var f in u){var l=u[f];if(l instanceof Array)for(o=l.length;o>=0;o--)c=c.replace(new RegExp(f+(o+1),"g"),l[o]);else c=c.replace(new RegExp(f,"g"),l)}if(n.innerHTML=c,a=e.length,r.firstChild&&1===a)s=n.firstChild;else for(o=0;a>o;o++)s.push(e[o]);return s};return r.firstChild=!1,r.exposeEmmet=function(){return t},r}(e);return r}();